//Configuration to ApprovalDirectives be in aplication.
var ApprovalDirectives = angular.module("ApprovalDirectives", []);
ZeedhiApp.requires.push('ApprovalDirectives');
// console.log(ZeedhiApp)
ApprovalDirectives.directive('appMask', function() {
    
    function maskApplyOnValueField($scope) {
        let field = $scope.field;
        switch(field.mask) {
            case 'currency':
                $scope.data[field.name] = formatMoney($scope.data[field.name]);
            break;
            case 'productAmount':
                $scope.data[field.name] = formatProductAmount($scope.data[field.name]);
            break;
            case 'productCode':
                $scope.data[field.name] = formatProductCode($scope.data[field.name]);
            break;
        }
    }
    
    function formatMoney(value) {
        value = parseFloat(value);
        return "R$" + value.toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+\,)/g, "$1.");
    }
    
    function formatProductAmount(value) {
        value = parseFloat(value);
        value = value.toFixed(3);
        return value.replace('.', ',');
    }
    
    function formatProductCode(value) {
        var mask = getLocalVar('CDPICTPROD');
        var pos = findLetterPositions(mask, '.');

        pos.forEach(f => {
            value = [value.slice(0, f), '.', value.slice(f)].join('');
        });
        
        return value;
    }

    function findLetterPositions(str, letter) {
        let positions = [];
        for (let i = 0; i < str.length; i++) {
            if (str[i] === letter) {
                positions.push(i);
            }
        }
        return positions;
    }
    
    return {
        link: maskApplyOnValueField
    };
    
});